> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tread.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Retrieve all JobEvents that belong to a Job

> Retrieve `Job` `Job-Events` by `ID`



## OpenAPI

````yaml /api-reference/openapi.json get /v1/jobs/{job-id}/job_events
openapi: 3.0.3
info:
  title: Horizon API V1
  version: '1.0'
  contact:
    name: Tread
    url: https://tread.io
    email: developers@tread.io
  description: >-
    This is the Version 1 implementation.


    When in doubt we default to the practices outlined
    [here](https://www.vinaysahni.com/best-practices-for-a-pragmatic-restful-api#advanced-queries)
  license:
    name: Private
    url: https://tread.io
servers:
  - description: production
    url: https://api.tread-horizon.com
security:
  - bearerAuth: []
tags:
  - name: Projects
  - name: Orders
  - name: Loads
  - name: Jobs
  - name: JobAssignments
  - name: ApprovalAssignments
  - name: Equipment
  - name: FuelSurcharges
  - name: Materials
  - name: Accounts
  - name: Tickets
  - name: Users
  - name: Sites
  - name: Companies
  - name: Departments
  - name: Rates
  - name: Services
  - name: EquipmentType
  - name: FileAttachments
  - name: MaterialType
  - name: LineItemType
  - name: DriverStateEvent
  - name: Authentication
  - name: IamRoles
  - name: Typeaheads
  - name: Integrations
  - name: Reflection
  - name: LoadCycles
  - name: AddOns
  - name: ServiceClass
  - name: Invoices
  - name: JobSummaries
  - name: LoadSummaries
  - name: CompanyShares
  - name: UserDevicePermission
  - name: Drivers
  - name: Settlements
  - name: LocationHistories
  - name: Telematics
  - name: OmniReports
  - name: DriverDays
  - name: Agave
  - name: AddOnCharges
  - name: ResourceUsageLogs
  - name: ResourceScopes
  - name: TravelledDistances
  - name: MaterialRates
  - name: CompanyDayJobStats
  - name: KMLFiles
  - name: AutoAddOnAssignments
  - name: SiteRateSchedules
  - name: TwilioIntegrations
  - name: Foremen
  - name: AccountExternalTruckIdentifier
  - name: GeofenceTriggers
  - name: Labels
  - name: Compliance
  - name: ComplianceDocuments
paths:
  /v1/jobs/{job-id}/job_events:
    parameters:
      - schema:
          type: string
          format: uuid
        name: job-id
        in: path
        required: true
        description: Job ID
      - $ref: '#/components/parameters/Accept-Language'
    get:
      tags:
        - Jobs
      summary: Retrieve all JobEvents that belong to a Job
      description: Retrieve `Job` `Job-Events` by `ID`
      operationId: get-v1-jobs-job-id-job_events
      parameters:
        - $ref: '#/components/parameters/page-limit'
        - $ref: '#/components/parameters/page-before'
        - $ref: '#/components/parameters/page-after'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    type: array
                    x-stoplight:
                      id: a5c0fcj0ne1j4
                    items:
                      $ref: '#/components/schemas/JobEvent-Read'
                required:
                  - data
          headers:
            Link:
              schema:
                type: string
              description: Contains prev and next links for pagination
        '401':
          $ref: '#/components/responses/UnauthenticatedError'
        '404':
          $ref: '#/components/responses/Error'
        '406':
          $ref: '#/components/responses/Error'
components:
  parameters:
    Accept-Language:
      name: Accept-Language
      in: header
      schema:
        type: string
        default: en
        example: en
      description: >-
        The Accept-Language request HTTP header indicates the natural language
        and locale that the client prefers. 
    page-limit:
      name: page[limit]
      in: query
      schema:
        type: integer
        format: int32
        default: 25
        maximum: 100
      description: The maximum number of paginated results to return
    page-before:
      name: page[before]
      in: query
      required: false
      schema:
        type: string
      description: The cursor to stop paginating at
    page-after:
      name: page[after]
      in: query
      required: false
      schema:
        type: string
      description: The cursor to start paginating after
  schemas:
    JobEvent-Read:
      title: JobEvent-Read
      x-stoplight:
        id: h80os065siwam
      allOf:
        - $ref: '#/components/schemas/Identifier'
        - type: object
          x-stoplight:
            id: dn8tvq80epohu
          required:
            - lat
            - lon
            - state
            - created_at
            - occurred_at
            - event_name
            - load_id
            - event_source
          properties:
            lat:
              type: string
              x-stoplight:
                id: ytqw1vq0z0ky8
              nullable: true
            lon:
              type: string
              x-stoplight:
                id: ihaf2njqbh2z4
              nullable: true
            state:
              $ref: '#/components/schemas/JobState'
            created_at:
              type: string
              x-stoplight:
                id: cks4qm6pi3n9j
              format: date-time
            occurred_at:
              type: string
              x-stoplight:
                id: t4ydbv175lyny
              format: date-time
            event_name:
              $ref: '#/components/schemas/JobEventName'
            load_id:
              type: string
              x-stoplight:
                id: 2swvreb0o0ub2
              format: uuid
              nullable: true
              readOnly: true
            created_by:
              $ref: '#/components/schemas/Principal-Read-Nested'
            event_source:
              $ref: '#/components/schemas/JobEventSource'
            payload:
              type: object
              x-stoplight:
                id: pstpn7wwugjo3
              properties:
                reject_reason:
                  type: string
                  x-stoplight:
                    id: p7ap3rqw5ojgh
                  nullable: true
                driver_id:
                  type: string
                  x-stoplight:
                    id: 8u5ztjl34tl22
                  format: uuid
                  nullable: true
                vendor_id:
                  type: string
                  x-stoplight:
                    id: 0o0neuk9gckbl
                  format: uuid
                  nullable: true
                label:
                  type: string
                  x-stoplight:
                    id: fmd6emklcgsr6
                  nullable: true
                  description: >-
                    The label of the attribute that was changed.


                    For `JobAttributeChanged` events, this value will be
                    translated per the `Accept-Language` header.
                from_value:
                  type: string
                  x-stoplight:
                    id: fmd8emklcgsr8
                  nullable: true
                to_value:
                  type: string
                  x-stoplight:
                    id: fmd7emklcgsr7
                  nullable: true
                value:
                  type: string
                  x-stoplight:
                    id: fmd6emklcgsr2
                  nullable: true
                warnings:
                  type: array
                  x-stoplight:
                    id: k8rn2vwpq1m4a
                  nullable: true
                  description: >-
                    Compliance warnings that were overridden. Present on
                    `ComplianceOverride` events.
                  items:
                    type: object
                    x-stoplight:
                      id: j7qm3uxtl2n5b
                    properties:
                      type:
                        type: string
                        x-stoplight:
                          id: h6pl2twsk3o6c
                      document_type:
                        type: string
                        x-stoplight:
                          id: g5ok1svri4p7d
                      document_type_id:
                        type: string
                        x-stoplight:
                          id: f4nj0ruqh5q8e
                        format: uuid
                      expires_at:
                        type: string
                        x-stoplight:
                          id: e3mi9qtpg6r9f
                        format: date-time
                        nullable: true
                      entity:
                        type: string
                        x-stoplight:
                          id: d2lh8psof7s0g
                blocking:
                  type: array
                  x-stoplight:
                    id: c1kg7ornea1h
                  nullable: true
                  description: >-
                    Compliance blocking issues that were overridden. Present on
                    `ComplianceOverride` events.
                  items:
                    type: object
                    x-stoplight:
                      id: b0jf6nqmdt2i
                    properties:
                      type:
                        type: string
                        x-stoplight:
                          id: a9ie5mplcs3j
                      document_type:
                        type: string
                        x-stoplight:
                          id: z8hd4lokbr4k
                      document_type_id:
                        type: string
                        x-stoplight:
                          id: y7gc3knjaq5l
                        format: uuid
                      expires_at:
                        type: string
                        x-stoplight:
                          id: x6fb2jmizp6m
                        format: date-time
                        nullable: true
                      entity:
                        type: string
                        x-stoplight:
                          id: w5ea1ilhyo7n
                overridden_by:
                  type: string
                  x-stoplight:
                    id: v4d90hkgxn8o
                  format: uuid
                  nullable: true
                  description: >-
                    The user ID of the person who overrode the compliance check.
                    Present on `ComplianceOverride` events.
                overridden_at:
                  type: string
                  x-stoplight:
                    id: u3c89gjfwm9p
                  format: date-time
                  nullable: true
                  description: >-
                    When the compliance override occurred. Present on
                    `ComplianceOverride` events.
    Identifier:
      title: Identifier
      x-stoplight:
        id: gnd39lue5v7ol
      type: object
      required:
        - id
      properties:
        id:
          type: string
          x-stoplight:
            id: 2e38hjk4zd58m
          format: uuid
      additionalProperties: false
    JobState:
      title: JobState
      x-stoplight:
        id: qyb8p2t7h0pnn
      enum:
        - created
        - assigned
        - accepted
        - rejected
        - to_pickup
        - arrived_pickup
        - loaded
        - to_dropoff
        - arrived_dropoff
        - unloaded
        - completed
        - canceled
        - ended
        - sent
        - in_review
        - flagged
        - signed_off
        - paid
        - load_completed
      example: created
      default: created
      readOnly: true
    JobEventName:
      title: JobEventName
      x-stoplight:
        id: dyiohh0t8x7l8
      enum:
        - JobCreated
        - JobUpdated
        - JobAssigned
        - JobUnassigned
        - JobSent
        - JobAccepted
        - JobDeclined
        - WaypointPending
        - WaypointArrived
        - WaypointAction
        - JobCanceled
        - JobCompleted
        - JobEnded
        - JobInReview
        - JobFlagged
        - JobSignedOff
        - JobPaid
        - JobRemovedSignedOff
        - JobRemovedFlagged
        - JobPaused
        - JobResumed
        - LoadCompleted
        - LoadCanceled
        - LoadUpdated
        - GeofenceEntered
        - GeofenceExited
        - OrderCompleted
        - OrderCanceled
        - ShiftEnded
        - NotificationSent
        - ToPickup
        - ToDropoff
        - AtPickup
        - AtDropoff
        - Loaded
        - Unloaded
        - JobRequested
        - JobLoading
        - JobUnloading
        - JobDriverChanged
        - JobEquipmentChanged
        - JobMaterialChanged
        - JobAttributeChanged
        - TicketChaseInitiated
        - TicketsUploadedByAgent
        - ComplianceOverride
        - LoadAiReviewed
    Principal-Read-Nested:
      title: Principal-Read-Nested
      x-stoplight:
        id: oyruvwz2a9ddh
      allOf:
        - type: object
          required:
            - type
          properties:
            type:
              x-stoplight:
                id: up9qg59l8x5s0
              enum:
                - User
                - Company
                - M2MClient
                - Impersonation
        - x-stoplight:
            id: lz1m1s1btit0u
          anyOf:
            - $ref: '#/components/schemas/Company-Read-Nested'
            - $ref: '#/components/schemas/M2MClient-Read-Nested'
            - $ref: '#/components/schemas/User-Read-Minimal'
            - $ref: '#/components/schemas/Impersonation-Read-Minimal'
    JobEventSource:
      title: JobEventSource
      x-stoplight:
        id: 97nr8yoreazxi
      enum:
        - web
        - webhook
        - automation
        - ticket_match
        - geofence
      description: Job Event Source Type
    UnauthenticatedError-Response:
      title: UnauthenticatedError-Response
      x-stoplight:
        id: o477eph7ttbzt
      type: object
      required:
        - error
      properties:
        error:
          $ref: '#/components/schemas/UnauthenticatedError'
      additionalProperties: false
    Error-Response:
      title: Error-Response
      x-stoplight:
        id: 52cydhphee3qe
      type: object
      required:
        - error
      properties:
        error:
          $ref: '#/components/schemas/Error'
      additionalProperties: false
    Company-Read-Nested:
      title: Company-Read-Nested
      x-stoplight:
        id: cb2kn77qmf1l7
      description: Compact Company model for nested reads.
      allOf:
        - $ref: '#/components/schemas/Identifier'
          x-stoplight:
            id: jwsufva4znm91
        - $ref: '#/components/schemas/TreadId'
        - type: object
          properties:
            legal_name:
              type: string
              x-stoplight:
                id: yc10t8hieecwk
              description: The Company's name. Must be globally unique.
            company_type:
              $ref: '#/components/schemas/CompanyType'
          required:
            - legal_name
            - company_type
    M2MClient-Read-Nested:
      title: M2MClient-Read-Nested
      x-stoplight:
        id: hf6su2qgixxmz
      allOf:
        - $ref: '#/components/schemas/Identifier'
        - type: object
          required:
            - company
          properties:
            company:
              $ref: '#/components/schemas/Company-Read-Nested'
    User-Read-Minimal:
      title: User-Read-Minimal
      x-stoplight:
        id: c25yzr29pbh5t
      allOf:
        - $ref: '#/components/schemas/User-Read-Typeahead'
        - $ref: '#/components/schemas/Discardable'
        - x-stoplight:
            id: qmk2e9npvoxcs
          type: object
          required:
            - company
          properties:
            company:
              $ref: '#/components/schemas/Company-Read-Nested'
    Impersonation-Read-Minimal:
      title: Impersonation-Read-Minimal
      x-stoplight:
        id: 1h5th7jnqtxix
      type: object
      required:
        - impersonator
        - impersonated
      properties:
        impersonator:
          $ref: '#/components/schemas/User-Read-Minimal'
        impersonated:
          $ref: '#/components/schemas/User-Read-Minimal'
    UnauthenticatedError:
      title: UnauthenticatedError
      x-stoplight:
        id: 202o69l0fs40h
      allOf:
        - $ref: '#/components/schemas/Error'
        - type: object
          x-stoplight:
            id: tg10dt7s0l6bw
          properties:
            error_type:
              type: string
              x-stoplight:
                id: wvq8c0qsym4hz
          required:
            - error_type
    Error:
      title: Error
      x-stoplight:
        id: 3g57kkik3l464
      type: object
      description: An Error.
      required:
        - code
      properties:
        code:
          type: string
          x-stoplight:
            id: 7o9x1t8v0bgfo
      additionalProperties: false
    TreadId:
      title: TreadId
      x-stoplight:
        id: 43k4t5tl359m4
      type: object
      required:
        - tread_id
      properties:
        tread_id:
          type: string
          x-stoplight:
            id: zi3ld7djflw6f
          pattern: ^[0-9A-F]{6}$
          minLength: 6
          maxLength: 6
          example: ABC123
          description: Tread ID
      additionalProperties: false
    CompanyType:
      title: CompanyType
      x-stoplight:
        id: dkzo7gjbtb1b3
      enum:
        - broker
        - contractor
        - hauler
        - owner_operator
        - producer
        - super
      example: hauler
      description: Company Type
    User-Read-Typeahead:
      title: User-Read-Typeahead
      x-stoplight:
        id: ttbbss5b5k66f
      allOf:
        - $ref: '#/components/schemas/Identifier'
        - type: object
          required:
            - first_name
            - last_name
          properties:
            first_name:
              type: string
              description: First name
              x-stoplight:
                id: gwo999rcdahmg
            last_name:
              type: string
              description: Last name
              x-stoplight:
                id: l9omnnsq644bh
      description: ''
    Discardable:
      title: Discardable
      x-stoplight:
        id: 46axlb8u5wjay
      type: object
      required:
        - discarded_at
      properties:
        discarded_at:
          type: string
          x-stoplight:
            id: cy8t6fecoyxbo
          format: date-time
          nullable: true
      additionalProperties: false
  responses:
    UnauthenticatedError:
      description: Example response
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/UnauthenticatedError-Response'
            type: object
    Error:
      description: Error response
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error-Response'
            type: object
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT

````